<template>
  <main class="main bg-light d-flex justify-content-between flex-column min-vh pt-4 pt-md-5">
    <div class="w-100 d-none d-md-block">
      <client-only>
        <p
          v-if="form"
          class="text-center text-dark"
          v-html="$t('namebook.for', {name: genitiveName })"
        />
      </client-only>
      <ul v-if="pagination.length" class="list-unstyled pagination">
        <template v-for="(letter, index) in name">
          <li
            v-if="pagination[index]"
            :key="letter + index"
            :class="{active: pagination[index].page_num + 1 === currentPage}"
            @click="jumpPage(pagination[index].page_num + 1)"
          >
            <span>{{ letter }}</span>
            <b-img :src="pagination[index].image | image" :alt="letter" />
          </li>
        </template>
      </ul>
    </div>
    <b-container v-if="$device.isMobile" class="position-relative d-flex align-items-center" style="overflow-x: scroll; flex: 1;">
      <div
        v-for="(page, index) in pages"
        :key="'page-mobile-' + page.page_num"
        class="pr-1 position-relative"
        :style="{height: 100/book.ratio.x + 'vw', width: (!index || index === pages.length - 1) ? 100 + 'vw' : 'calc(200vw - 30px)' }"
      >
        <v-lazy-image
          :src-placeholder="page.image | image | imageSize('small')"
          :src="page.image | image"
          :alt="page.page_num"
          class="h-100"
          :style="{width: (!index || index === pages.length - 1) ? 100 + 'vw' : 'calc(200vw - 30px)' }"
        />
        <span
          v-if="page.is_box"
          class="box"
          :style="{left: (page.x) + '%', top: page.y + '%', transform: 'rotate('+page.deg+'deg)'}"
        >{{ getLetter(page) }}</span>

        <ul v-if="index === pages.length - 2 && nameLogic.length" class="list-unstyled">
          <template v-for="(letter, letterIndex) in name">
            <li
              v-if="nameLogic[letterIndex]"
              :key="'box' + letterIndex"
              class="box box--lg"
              :style="{left: nameLogic[letterIndex].x + '%', top: nameLogic[letterIndex].y + '%', transform: 'rotate('+nameLogic[letterIndex].deg+'deg)'}"
            >
              {{ letter }}
            </li>
          </template>
        </ul>
      </div>
    </b-container>
    <b-container v-else class="position-relative">
      <div ref="bookWrapper" class="w-100 py-md-5">
        <div
          v-if="pages.length && size.width && size.height"
          id="bb-bookblock"
          ref="bookBlock"
          v-bookblock="bookOptions"
          class="bb-bookblock"
          :style="{ width: size.width + 'px', height: size.height + 'px' }"
        >
          <client-only>
            <div
              v-for="(page, index) in pages"
              :key="'page-' + page.page_num"
              class="bb-item"
            >
              <div
                v-if="index"
                class="page"
                :class="{'end': index === pages.length - 1}"
                :style="{backgroundImage: 'url(' + $options.filters.image(page.image) + ')'}"
                @click="prevPage()"
              >
                <span
                  v-if="page.is_box && page.x < 50"
                  class="box"
                  :style="{left: (size.width * page.x/100) + 'px', top: page.y + '%', transform: 'rotate('+page.deg+'deg)'}"
                >{{ getLetter(page) }}</span>

                <ul v-if="index === pages.length - 2 && nameLogic.length" class="list-unstyled">
                  <template v-for="(letter, letterIndex) in name">
                    <li
                      v-if="nameLogic[letterIndex] && nameLogic[letterIndex].x < 50"
                      :key="'box' + letterIndex"
                      class="box box--lg"
                      :style="{left: (size.width * nameLogic[letterIndex].x/100) + 'px', top: nameLogic[letterIndex].y + '%', transform: 'rotate('+nameLogic[letterIndex].deg+'deg)'}"
                    >
                      {{ letter }}
                    </li>
                  </template>
                </ul>
              </div>
              <div
                v-if="index < pages.length - 1"
                class="page"
                :class="{'cover': !index}"
                :style="{backgroundImage: 'url(' + $options.filters.image(page.image) + ')'}"
                @click="nextPage()"
              >
                <span
                  v-if="page.is_box && page.x >= 50"
                  class="box"
                  :style="{left: (size.width * page.x/100 - size.width/2) + 'px', top: page.y + '%', transform: 'rotate('+page.deg+'deg)'}"
                >{{ getLetter(page) }}</span>

                <ul v-if="index === pages.length - 2 && nameLogic.length" class="list-unstyled">
                  <template v-for="(letter, letterIndex) in name">
                    <li
                      v-if="nameLogic[letterIndex] && nameLogic[letterIndex].x >= 50"
                      :key="'box' + letterIndex"
                      class="box box--lg"
                      :style="{left: (size.width * nameLogic[letterIndex].x/100 - size.width/2) + 'px', top: nameLogic[letterIndex].y + '%', transform: 'rotate('+nameLogic[letterIndex].deg+'deg)'}"
                    >
                      {{ letter }}
                    </li>
                  </template>
                </ul>
              </div>
            </div>
          </client-only>
        </div>
      </div>
    </b-container>
    <client-only>
      <div
        v-if="navItems && navItems.length"
        v-click-outside="hideExpandItem"
        class="book-footer"
        :class="{'shadow-top-lg': !itemExpanded}"
      >
        <div v-show="itemExpanded" class="expanded">
          <b-container>
            <!--            <keep-alive>-->
            <transition name="fade" mode="out-in">
              <namebook-form
                v-if="itemExpanded === 'form'"
                :book="book"
                :form-data="form"
                form-class="pt-5 pt-md-0 mt-5 mt-md-0"
                @hide="hideExpandItem"
              />
              <namebook-dedication
                v-else-if="itemExpanded === 'dedication'"
                :name="name"
                :book="book"
                :dedication-text="dedicationText"
                @setDedication="getDedication"
                @hide="hideExpandItem"
              >
                <p class="text-dark mb-0">
                  {{ $t('namebook.dedication_title', {name: genitiveName }) }}
                </p>
                <p class="text-secondary mb-3 mb-xl-4 small">
                  {{ $t('namebook.dedication_text') }}
                </p>
              </namebook-dedication>
              <namebook-addons v-else-if="itemExpanded === 'addons'" />
            </transition>
            <!--            </keep-alive>-->
          </b-container>
        </div>
        <b-container class="px-0 px-md-3">
          <div class="d-flex flex-column flex-md-row justify-content-around justify-content-md-between align-items-center">
            <div class="d-flex flex-column flex-md-row flex-wrap flex-md-nowrap sm-100">
              <div
                v-for="item in navItems"
                :key="item.key"
                class="expand border-left border-right px-3 p-lg-3 p-xl-4"
                :class="{'expand--active': itemExpanded === item.key}"
                @click="expandItem(item.key)"
              >
                <div class="d-flex align-items-center justify-content-between justify-content-md-start flex-row flex-nowrap mb-1">
                  <small>{{ item.name }}</small>
                  <img
                    :src="itemExpanded === item.key ? chevrons.up : chevrons.down"
                    alt="Chevron"
                    class="icon"
                  >
                </div>
                <strong>{{ item.value }}</strong>
              </div>
            </div>
            <b-button
              v-if="itemExpanded === 'addons'"
              type="submit"
              variant="primary"
              class="btn--right m-3 ml-md-2 mr-md-0 my-md-0"
              @click="onContinue"
              v-html="$t('cart.buy_for', { price })"
            />
            <b-button
              v-else
              type="submit"
              variant="outline-secondary"
              class="btn--right m-3 ml-md-2 mr-md-0 my-md-0"
              @click="onContinue"
            >
              {{ $t('continue') }}
            </b-button>
          </div>
        </b-container>
      </div>
    </client-only>
  </main>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import namebookForm from '~/components/namebook/Form.vue'
import namebookDedication from '~/components/namebook/Dedication.vue'
import namebookAddons from '~/components/namebook/Addons.vue'
import chevronUp from '~/static/icons/up-chevron.svg'
import chevronDown from '~/static/icons/down-chevron.svg'

export default {
  name: 'AppNamebookPreviewPage',
  middleware: 'namebookQueried',
  components: {
    namebookForm,
    namebookDedication,
    namebookAddons
  },
  async fetch ({ store, params }) {
    const language = await store.getters['book/getLanguage']
    await store.dispatch('book/FETCH_BOOK', {
      id: params.id,
      type: 'namebooks',
      language
    })
    await store.dispatch('book/FETCH_ADDONS')
  },
  data () {
    return {
      carouselSettings: {
        arrows: true,
        dots: false,
        infinite: false,
        autoplay: false,
        accessibility: true,
        draggable: true,
        variableWidth: true,
        slidesToShow: 1
      },
      bookOptions: {
        orientation: 'vertical'
      },
      pagination: [],
      nameLogic: [],
      pages: [],
      size: {
        width: 0,
        height: 0
      },
      currentPage: 1,
      chevrons: {
        up: chevronUp,
        down: chevronDown
      },
      dedication: '',
      itemExpanded: null
    }
  },
  computed: {
    ...mapGetters({
      form: 'book/getForm',
      book: 'book/getBook',
      activeAddons: 'book/getActiveAddons',
      currency: 'currency/getCurrency',
      currencies: 'currency/getCurrencies'
    }),
    name () {
      return this.form ? this.form.name : ''
    },
    genitiveName () {
      return this.$options.filters.genitive(this.name, this.$i18n.locale, this.form.gender)
    },
    language () {
      return this.form ? this.form.language : 'ru'
    },
    character () {
      return this.form && this.form.character ? this.form.character.id : ''
    },
    bookblock () {
      return this.$refs.bookBlock.bookblock
    },
    dedicationText () {
      if (this.dedication) {
        return this.dedication
      } else {
        if (this.editableItem) {
          return this.editableItem.dedication
        } else if (this.book && this.book.dedication) {
          return this.book.dedication.text.replace('$name', this.name)
        }
        return ''
      }
    },
    navItems () {
      return [
        {
          name: this.$t('form.character'),
          key: 'form',
          value: this.form ? this.form.name : ''
        },
        {
          name: this.$t('form.dedication'),
          key: 'dedication',
          value: this.dedication || this.dedicationText
        },
        {
          name: this.$t('namebook.addons'),
          key: 'addons',
          value: this.$t('namebook.addons_title')
        }
      ]
    },
    price () {
      let price = this.book.price
      price = price + this.addonsPrice
      if (this.currencyObj && this.currencyObj.kod !== 'KZT') {
        price = (price / parseFloat(this.currencyObj.kurs)).toFixed(2)
      }
      return this.$options.filters.price(price, this.currency || 'KZT')
    },
    addonsPrice () {
      const len = this.activeAddons.length
      if (len > 1) {
        const reducer = (accumulator, currentValue) => accumulator.price + currentValue.price
        return this.activeAddons.reduce(reducer)
      } else if (len === 1) {
        return this.activeAddons[0].price
      }
      return 0
    },
    currencyObj () {
      if (this.currency && this.currencies.length) {
        return this.currencies.find(item => item.kod === this.currency)
      }
      return null
    },
    editableItem () {
      if (this.$route.name.startsWith('namebooks-id-edit')) {
        return this.$store.getters['cart/getItems'].find(item => item.id === this.$route.query.item)
      }
      return null
    }
  },
  watch: {
    currentPage () {
      if (this.currentPage === this.pages.length) {
        this.bookblock.el.classList.add('bb-bookblock--end')
      } else {
        this.bookblock.el.classList.remove('bb-bookblock--end')
      }
    },
    form: {
      handler () {
        this.getPagination()
        this.getPages()
        this.defineSize()
        this.getName()
      },
      deep: true
    }
  },
  mounted () {
    this.dedication = this.dedicationText
    if (this.editableItem) {
      this.setActiveAddons(this.editableItem.addons)
      const { name, language, character, gender, book } = this.editableItem
      this.setForm({
        name,
        language,
        character,
        gender,
        book
      })
    } else if (!this.form) {
      const path = this.localePath({
        name: 'namebooks-id',
        params: { id: this.$route.params.id }
      })
      this.$router.push({ path })
    }
    this.getPagination()
    this.getPages()
    this.defineSize()
    this.getName()
  },
  destroyed () {
    this.removeActiveAddons()
    this.clearForm()
  },
  methods: {
    async getPagination () {
      const { data } = await this.$axios.$get('namebooks/' + this.$route.params.id + '/pagination', {
        params: {
          letter_count: this.name.length
        }
      })
      this.pagination = data
    },

    async getName () {
      const { data } = await this.$axios.$get('namebooks/' + this.$route.params.id + '/name', {
        params: {
          letter_count: this.name.length
        }
      })
      this.nameLogic = data
    },
    async getPages () {
      const { data } = await this.$axios.$get('namebooks/' + this.$route.params.id + '/pages', {
        params: {
          name: this.name,
          lang: this.language,
          character: this.character
        }
      })
      this.pages = data
    },
    defineSize () {
      if (this.$refs.bookWrapper) {
        const { width } = this.$refs.bookWrapper.getBoundingClientRect()
        this.size.width = width
        this.size.height = Math.round(width * this.book.ratio.y / (2 * this.book.ratio.x))
      }
    },
    prevPage () {
      if (this.currentPage) {
        this.currentPage = this.currentPage - 1
        this.bookblock.prev()
      }
    },
    nextPage () {
      if (this.currentPage < this.pages.length) {
        this.currentPage = this.currentPage + 1
        this.bookblock.next()
      }
    },
    jumpPage (position) {
      this.currentPage = position
      this.bookblock.jump(position)
    },
    expandItem (item) {
      if (this.itemExpanded === item) {
        this.hideExpandItem()
      } else {
        this.hideExpandItem()
        this.itemExpanded = item
      }
    },
    hideExpandItem () {
      this.itemExpanded = null
    },
    onContinue () {
      if (this.itemExpanded === 'form') {
        this.expandItem('dedication')
      } else if (this.itemExpanded === 'dedication') {
        this.expandItem('addons')
      } else if (this.itemExpanded === 'addons') {
        const payload = Object.assign({}, this.form)
        payload.product = this.book
        payload.dedication = this.dedication
        payload.addons = this.activeAddons
        if (this.editableItem) {
          payload.id = this.editableItem.id
          this.updateCartItem(payload).then(() => {
            const path = this.localePath({
              name: 'cart'
            })
            this.$router.push({ path })
          })
        } else {
          payload.id = this.$uuid.v4()
          this.addToCart(payload).then(() => {
            const path = this.localePath({
              name: 'cart'
            })
            this.$router.push({ path })
          })
        }
      } else {
        this.expandItem('dedication')
      }
    },
    getDedication (dedication) {
      this.dedication = dedication
    },
    closeModal () {
      this.$bvModal.hide('bookModal')
    },
    getLetter (page) {
      const index = this.pagination.findIndex(item => item.page_num === page.page_num)
      return this.form.name[index]
    },
    ...mapActions({
      removeActiveAddons: 'book/REMOVE_ACTIVE_ADDONS',
      clearForm: 'book/CLEAR_FORM',
      setForm: 'book/SET_FORM',
      addToCart: 'cart/ADD_TO_CART',
      updateCartItem: 'cart/UPDATE_CART_ITEM',
      setActiveAddons: 'book/SET_ACTIVE_ADDONS'
    })
  }
}
</script>

<!--suppress CssUnknownTarget -->
<style lang="scss">
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";
    @import "@/assets/scss/book.scss";

    .pagination {
        align-items: center;
        justify-content: center;
        @include media-breakpoint-down(sm) {
            display: none;
        }

        li {
            margin: 0 0.5rem;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            cursor: pointer;

            span {
                margin-bottom: 0.25rem;
                color: $secondary;
                text-transform: uppercase;
                @include media-breakpoint-down(sm) {
                    font-size: $font-size-sm;
                }
            }

            img {
                width: 2.5rem;
                height: 2.5rem;
                object-fit: contain;
                border-radius: 0.25rem;
                border: 2px solid transparent;
                padding: 0.1rem;
                background-color: white;
                @include media-breakpoint-down(sm) {
                    width: 0.25rem;
                    height: 0.25rem;
                    background-color: $dark;
                    padding: 0;
                }
            }

            &:hover, &.active {
                span {
                    color: $primary;
                    font-weight: bold;
                }

                img {
                    border-color: lighten($primary, 10%);
                    @include media-breakpoint-down(sm) {
                        background-color: $primary;
                    }
                }
            }
        }
    }

    .bb-bookblock {
        &--end {
            transform: translateX(25%) !important;
        }

        .page {
            background-repeat: no-repeat;
            background-size: 200% 100%;
            transition: transform .9s ease;
            cursor: pointer;
            position: relative;
            padding: 1rem;
            border-top: 1px solid rgba(0, 0, 0, 0.06);
            border-bottom: 1px solid rgba(0, 0, 0, 0.06);

            &.cover, .end {
                background-size: cover;
                background-position: center center;

                .page__heading {
                    position: absolute;
                    color: white;
                    transform: rotate3d(0, 1, 0, -90deg);
                    width: 40px;
                    left: -20px;
                }
            }

            &.cover {
                &:after {
                    content: '';
                    position: absolute;
                    top: 0;
                    left: 0.5rem;
                    bottom: 0;
                    width: 3px;
                    background: rgba(0, 0, 0, 0.06);
                    box-shadow: 1px 0 3px rgba(255, 255, 255, 0.1);
                }
            }

            &.end {
                background-size: cover !important;
                &:after {
                    content: '';
                    position: absolute;
                    top: 0;
                    right: 0.5rem;
                    bottom: 0;
                    width: 3px;
                    background: rgba(0, 0, 0, 0.06);
                    box-shadow: 1px 0 3px rgba(255, 255, 255, 0.1);
                }
            }

            &:not(.cover):first-of-type {
                background-position: left center;
                transform-origin: 100%;
                border-left: 1px solid rgba(0, 0, 0, 0.06);

                &:hover {
                    transform: rotateY(10deg);
                }
            }

            &:not(.end):last-of-type {
                background-position: right center;
                transform-origin: 0;
                border-right: 1px solid rgba(0, 0, 0, 0.06);

                &:hover {
                    transform: rotateY(-10deg);
                }
            }

            + .page {
                &:before {
                    content: '';
                    position: absolute;
                    top: 0;
                    left: -1.5px;
                    bottom: 0;
                    width: 3px;
                    background: rgba(0, 0, 0, 0.06);
                    box-shadow: 1px 0 3px rgba(255, 255, 255, 0.1);
                }
            }
        }
    }

    .box {
      position: absolute;
      z-index: 1;
      font-size: 2rem;
      line-height: 1;
      text-transform: uppercase;
      color: $dark;
      font-weight: 900;
      font-family: 'Iskra', sans-serif;
      width: 2rem;
      height: 2rem;
      text-align: center;
      @include media-breakpoint-down(sm) {
        font-size: 1.25rem;
        width: 1.25rem;
        height: 1.25rem;
      }
      &--lg {
        font-size: 2.5rem;
        width: 2.5rem;
        height: 2.5rem;
        @include media-breakpoint-down(sm) {
          font-size: 1.5rem;
          width: 1.5rem;
          height: 1.5rem;
        }
      }
    }

    .book-footer {
        background-color: white;
        width: 100%;
        position: relative;
        z-index: 1000;
        display: block;
        @include media-breakpoint-down(sm) {
            .sm-100 {
                width: 100%;
                max-width: 100%;
            }

            .btn--right {
                width: calc(100% - 2rem);
            }
        }

        .expand {
            min-width: 10rem;
            max-width: 15rem;
            cursor: pointer;
            display: flex;
            flex-direction: column;
            justify-content: center;
            @include media-breakpoint-down(sm) {
                width: 100%;
                max-width: 100%;
                border-left-width: 0 !important;
                border-right-width: 0 !important;
                border-bottom: 1px solid $border-color;
                height: 4rem;
            }

            @media (max-width: 767.98px) and (max-height: 600px) {
                height: 3rem;
            }

            small {
                color: $secondary;
                white-space: nowrap;
            }

            .icon {
                width: 1rem;
                height: 1rem;
                object-fit: contain;
                margin-left: 0.5rem;
            }

            strong {
                width: 100%;
                text-overflow: ellipsis;
                overflow: hidden;
                white-space: nowrap;
                color: $dark;
                @include media-breakpoint-down(sm) {
                   font-size: $font-size-sm;
                }
            }

            &--active {
                background-color: $light;
            }
        }

        .expanded {
            /*overflow: hidden;*/
            box-shadow: $box-shadow-top-lg;
            background-color: $light;
            position: absolute;
            width: 100%;
            left: 0;
            top: 0;
            transform: translateY(-100%);
            padding: 1rem 0;
            z-index: 1000;
            max-height: 100vh;
            display: flex;
            align-items: flex-end;
            @include media-breakpoint-down(sm) {
                overflow-y: auto;
                height: calc(100vh - 9.5rem);
                align-items: center;
                top: initial;
                bottom: 4.5rem;
                transform: none;
            }
        }
    }

    .preview {
        height: 1.5rem;
        width: 1.5rem;
        object-fit: contain;
        background-color: white;
        padding: 0.25rem;
        border-radius: 50%;
        position: absolute;
        bottom: 1rem;
        right: 1rem;
        z-index: 1000;
        box-shadow: 0 .125rem .25rem rgba(black, .075);
        outline: none;
        @include media-breakpoint-up(md) {
            display: none;
        }
    }

    #bookModal {
        height: 100vh;

        .modal-dialog {
            margin: 0;
        }

        .modal-content {
            border-radius: 0;
            height: 100vh;
        }
    }
</style>
